;;; Common part of hash implementations
;;; (c) Ufasoft 2011
;;; This software is PUBLIC DOMAIN


(defpackage :hash-common
  (:export #:hash-common))

(in-package :hash-common)


(defun hash-common (stm hb res)
  (let ((blk (make-array 64))
        (len 0)
        last)
      (loop
        (fill blk 0)
        (if last (return))
        (dotimes (i 64)
          (setf (svref blk i) (or (read-byte stm nil)
                                  (progn (setq last t) #x80)))
          (if last (return))
          (incf len))
        (if (and last (< (logand len 63) 56)) (return))
        (funcall hb blk))
	(setq len (ash len 3))
	(dotimes (i 8)
      (setf (svref blk (+ 56 i))
            (ldb (byte 8 (ash i 3)) len)))
    (funcall hb blk))
  (funcall res))





